// C Source File
// Created 29/10/2003; 16:36:35

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS
#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization
#define MIN_AMS 200           // Compile for AMS 1.00 or higher

#include "KDEvar.h"
#include "Passwords.h"
void _main(void)
{
	HANDLE handle;
	HANDLE ans;
	LCD_BUFFER home_screen;
	LCD_save(home_screen);
  paint();
  key=0;	// because key contains the last key value from previous execution of KDE
  exit:
	if(key!=0){
		GrayOff();
		curX=0; curY=0;
		LCD_restore(home_screen);
		ST_showHelp("KDE v0.1 by Bastien JANSEN");
		return;
	}
	do{
		short result=0;
		if(key!=0)Sprite16(curX, curY, 16, curSprite, GrayGetPlane(DARK_PLANE), SPRT_XOR);
		switch (key){
	  	case 344:if(curX+16<160)curX+=speed; 	break;		// key right
	  	case 338:if(curX>0)curX-=speed; 			break;		// key left
	  	case 337:if(curY>0)curY-=speed; 			break;		// key down
	  	case 340:if(curY+16<100)curY+=speed; 	break;		// key up
	  	case 268:getClickPos(curX, curY, &key);					// if the user clicks
							 if(key!=277)break;
			case 277:
				handle=PopupNew("KDE StartMenu", 40);
				PopupAddText(handle, -1, "Setup", 1);
				PopupAddText(handle, 0, "Turn off", 2);
				PopupAddText(handle, 2, "Protege", 3);
				PopupAddText(handle, 2, "Don't protege", 4);
				PopupAddText(handle, -1, "Exit", 5);
				ans=PopupBegin(handle, 0);
				result = PopupBeginDo (ans, 0, 45, 0);
	 			MenuEnd (ans);
	  		switch(result){
	  			case 1:
	  				setup();
	  				paint();
	  				break;
	  			case 3:
	  				off();
	 					if(pwdEnabled)getPwd();
	 					paint();
	 					break;	
	  			case 4:
	  				off();
	  				break;
	  			case 5:
	  				goto exit;
	  			default:break;
	  		}
		}
		Sprite16(curX, curY, 16, curSprite, GrayGetPlane(DARK_PLANE), SPRT_XOR);
		key=GKeyIn(NULL, 0);
	}	while(key!=KEY_ESC);
	goto exit;
}
void paint(){
	SYM_ENTRY *sym;
		GrayOn();
		clrscr();
	  GraySetAMSPlane(DARK_PLANE);
  	//	Draws the GUI
	  DrawStr(3, LCD_HEIGHT-15, "K", A_NORMAL);
  	DrawLine(0,82, 160, 82, A_NORMAL);
	  DrawLine(14,82,14,93,A_NORMAL);
  	DrawLine(0,93,160,93, A_NORMAL);
	  //	Draws a picture
	  sym=SymFindPtr(SYMSTR(pic1),0);
	  if(sym)	BitmapPut(5,5,HeapDeref (sym->handle) + 2, ScrRect, A_NORMAL);
		if(strcmp(pic0,"nopictur")){
		  GraySetAMSPlane(LIGHT_PLANE);
 			sym=SymFindPtr(SYMSTR(pic0),0);
			if(sym)BitmapPut(5,5,HeapDeref (sym->handle) + 2, ScrRect, A_NORMAL);
		}
	//------------------
	return;
}

void changeBgPic(){
	clrscr();
	printf("= Background picture =\n");
	printf("Is your pic a 4-level grayscale pic? (y/n)");
	short key;
	do{
		key=ngetchx();
		if(key=='y' || key=='n')break;
	}while(1);
	if(key=='y'){
		printf("\nEnter 1st picture name :\n");
		inputStr(0);
		strcpy(pic0, input);
		printf("\nEnter 2nd picture name :\n");
		inputStr(0);
		strcpy(pic1, input);
	} else{
		printf("\nEnter picture name :\n");
		inputStr(0);
		strcpy(pic1, input);
		strcpy(pic0, "nopictur");
	}
	return;
}

void setup(){
	GrayOff();
	clrscr();
	printf("KDE Setup Configurator :\n\n");
	printf("1-Change background pic\n"\
				 "2-Enable/disable password\n"\
				 "3-Change cursor speed\n"\
				 "4-Exit setup\n\n");
	short key;
	do{
		key=ngetchx();
		switch(key){
			case '1':changeBgPic();return;
			case '2':setPwd();return;
			case '3':
				begin:
				clrscr();
				printf("Enter a value between 1 and 16 :\n\n");
				inputStr(0);
				if(atoi(input)<1 || atoi(input)>16)goto begin;
				speed=atoi(input);
				printf("\n\nCursor speed set to %d\n\nStrike any key...\n", speed);
				ngetchx();
				return;
			case '4':return;
		}
	}while(1);
	return;
}
